<?php

namespace Pinpoint\ProductPersonalisation\Block\Product\Preview;

use Magento\Framework\View\Element\Template;

/**
 * Class Css
 * @package Pinpoint\ProductPersonalisation\Block\Product\Preview
 */
class Css extends Template
{
    /**
     * @var string $_template
     */
    protected $_template = "Pinpoint_ProductPersonalisation::product/fontscss.phtml";

    /**
     * @var \Magento\Framework\Registry
     */
    protected $registry;

    /**
     * @var \Pinpoint\ProductPersonalisation\Model\Font
     */
    protected $fonts;

    /**
     * Css constructor.
     * @param Template\Context $context
     * @param \Magento\Framework\Registry $registry
     * @param \Pinpoint\ProductPersonalisation\Model\Font $fonts
     * @param array $data
     */
    public function __construct(
        Template\Context $context,
        \Magento\Framework\Registry $registry,
        \Pinpoint\ProductPersonalisation\Model\Font $fonts,
        array $data = []
    ) {
        $this->registry = $registry;
        $this->fonts = $fonts;

        parent::__construct($context, $data);
    }

    /**
     * @return \Magento\Catalog\Model\Product
     */
    public function getProduct()
    {
        return $this->registry->registry('current_product');
    }

    /**
     * @return array
     */
    public function getFonts()
    {
        $fonts = [];
        foreach ($this->fonts->getCollection()->getItems() as $font) {
            $filePath = $this->_filesystem->getDirectoryRead('media')->getAbsolutePath() . 'pinpoint_fonts' . DIRECTORY_SEPARATOR . $font->getData('font_file');
            $file = file_get_contents($filePath);
            $mime = mime_content_type($filePath);

            $fonts[] = $font->setData('font_file', 'data:' . $mime . ';charset=utf-8;base64,'. base64_encode($file));
        }

        return $fonts;
    }
}